﻿<%@ WebHandler Language="C#" Class="PrintReachPay" %>
using System;
using System.Web;
using System.IO;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json;

public class PrintReachPay : IHttpHandler
{

    public void ProcessRequest(HttpContext context)
    {
        context.Response.AddHeader("Access-Control-Allow-Origin", "*");
        context.Response.AddHeader("Access-Control-Allow-Methods", "GET, POST");
        context.Response.AddHeader("Access-Control-Allow-Headers", "Content-Type, Accept");
        context.Response.ContentType = "application/json";
        WebResponse response = new WebResponse();

        try
        {
            //if (!WebUser.CanXML())
            //{
            //    context.Response.StatusCode = (int)System.Net.HttpStatusCode.Forbidden;
            //    response.error = "Web2Plan Not Enabled";
            //    context.Response.Write(JsonConvert.SerializeObject(response));
            //}

            if (context.Request.RequestType == "POST")
            {
                var requestheaders = context.Request.Headers;
                var requestBody = string.Empty;

                PaymentModel payment = new PaymentModel();
                PaymentModelSavedCard.Root paymentSavedCard = new PaymentModelSavedCard.Root();

                using (StreamReader reader = new StreamReader(context.Request.InputStream))
                {
                    context.Request.InputStream.Position = 0;                                   //We need to set the Stream position to 0 before ReadToEnd otherwise we get a null requestBody
                    requestBody = reader.ReadToEnd();
                }

                string decodedbody = "";
                string paymentType = context.Request.QueryString["PaymentType"] == null ? "" : context.Request.QueryString["PaymentType"].ToLower();
                //Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + " Req Body Test: " + requestBody, "_PrintReachPayDevWebhookLog");

                string error = "";
                bool usingJobID = true;

                JObject Json = new JObject();
                try
                {
                    decodedbody = context.Server.UrlDecode(requestBody);
                    if (decodedbody.Contains("json="))
                    {
                        decodedbody = decodedbody.Remove(0, 5); //Removes json= at the beggning of the string for parsing
                    }
                    Json = JObject.Parse(decodedbody);
                    //Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + " Req Body Test: " + requestBody, "_PrintReachPayDevWebhookLog");

                    if (paymentType == "savecard")
                    {
                        paymentSavedCard = Json.ToObject<PaymentModelSavedCard.Root>();
                    }
                    else
                    {
                        payment = Json.ToObject<PaymentModel>();
                    }
                }
                catch (Exception ex)
                {
                    try
                    {
                        //decodedbody += "}"; //In some instances we are recieving json missing the last bracket, causing a parsing error.

                        Json = JObject.Parse(decodedbody);
                        if (paymentType == "savecard")
                        {
                            paymentSavedCard = Json.ToObject<PaymentModelSavedCard.Root>();
                        }
                        else
                        {
                            payment = Json.ToObject<PaymentModel>();
                        }
                    }
                    catch (Exception exc)
                    {
                        Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + "JSon Parse Exception: " + exc.Message, "_PrintReachPayWebhookLog");


                        context.Response.StatusCode = (int)System.Net.HttpStatusCode.InternalServerError;
                        response.error = exc.Message;
                        context.Response.Write(JsonConvert.SerializeObject(response));
                        return;
                    }

                }

                if (paymentType == "savecard")
                {
                    payment = null;
                    if (paymentSavedCard.requestDetails.merchantId == "" || !WebUser.GetMerchantIDs().Contains(paymentSavedCard.requestDetails.merchantId))
                    {
                        //Fail
                        Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + " - PrintReach Pay Payment Failure: MerchantID is Blank or Incorrect /n Json: " + decodedbody, "_PrintReachPayWebhookLog");
                        response.error = "MerchantID is invalid";
                        context.Response.StatusCode = (int)System.Net.HttpStatusCode.BadRequest;
                        context.Response.Write(JsonConvert.SerializeObject(response));
                        return;

                    }
                    else if (paymentSavedCard.requestDetails.invoiceNumber == "")
                    {
                        //Fail
                        Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + " - PrintReach Pay Payment Failure: InvoiceID is Blank /n Json: " + decodedbody, "_PrintReachPayWebhookLog");
                        response.error = "No Invoice Numbers";
                        context.Response.StatusCode = (int)System.Net.HttpStatusCode.BadRequest;
                        context.Response.Write(JsonConvert.SerializeObject(response));
                        return;
                    }
                    else if (paymentSavedCard.transactionID == 1)
                    {
                        Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + " - PrintReach Pay Payment Test: GatewayTransactionID is Blank /n Json: " + decodedbody, "_PrintReachPayWebhookLog");
                        response.isSuccessful = true;
                        response.data = "Test Successful";
                        context.Response.StatusCode = (int)System.Net.HttpStatusCode.OK;
                        context.Response.Write(JsonConvert.SerializeObject(response));
                        return;
                    }

                    if (paymentSavedCard.invoicesPaid != null)
                    {
                        foreach (InvoiceDetails id in paymentSavedCard.invoicesPaid)
                        {
                            if (id.invoiceID == "0")
                            {
                                usingJobID = false;
                            }
                        }
                    }
                    else
                    {
                        usingJobID = false;
                    }
                }
                else
                {
                    paymentSavedCard = null;
                    if (payment.requestDetails.merchantId == "" || !WebUser.GetMerchantIDs().Contains(payment.requestDetails.merchantId))
                    {
                        //Fail
                        Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + " - PrintReach Pay Payment Failure: MerchantID is Blank or Incorrect /n Json: " + decodedbody, "_PrintReachPayWebhookLog");
                        response.error = "MerchantID is invalid";
                        context.Response.StatusCode = (int)System.Net.HttpStatusCode.BadRequest;
                        context.Response.Write(JsonConvert.SerializeObject(response));
                        return;

                    }
                    else if (payment.requestDetails.invoiceNumber == "")
                    {
                        //Fail
                        Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + " - PrintReach Pay Payment Failure: InvoiceID is Blank /n Json: " + decodedbody, "_PrintReachPayWebhookLog");
                        response.error = "No Invoice Numbers";
                        context.Response.StatusCode = (int)System.Net.HttpStatusCode.BadRequest;
                        context.Response.Write(JsonConvert.SerializeObject(response));
                        return;
                    }
                    else if (payment.gatewayResponse.transactionID == 1)
                    {
                        Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + " - PrintReach Pay Payment Test: GatewayTransactionID is Blank /n Json: " + decodedbody, "_PrintReachPayWebhookLog");
                        response.isSuccessful = true;
                        response.data = "Test Successful";
                        context.Response.StatusCode = (int)System.Net.HttpStatusCode.OK;
                        context.Response.Write(JsonConvert.SerializeObject(response));
                        return;
                    }

                    if (payment.invoicesPaid != null)
                    {
                        foreach (InvoiceDetails id in payment.invoicesPaid)
                        {
                            if (id.invoiceID == "0")
                            {
                                usingJobID = false;
                            }
                        }
                    }
                    else
                    {
                        usingJobID = false;

                    }
                }



                if (usingJobID) //PRC Invoice Payment, possibly with multiple invoices paid.
                {
                    error = DataBase.PrintReachPayInvoicePaid(payment, paymentSavedCard);
                }
                else //HPP Payment which uses the Job Number, not the JobID
                {
                    if (paymentType == "savecard")
                    {
                        string payAmount;
                        decimal paymentAmount = 0;
                        decimal surCharge = 0;

                        decimal.TryParse(paymentSavedCard.surchargeDetails.surchargeAmount, out surCharge);


                        paymentAmount = paymentSavedCard.amountDetails.approvedTotalAmount - surCharge;
                        payAmount = String.Format("{0:0.00}", paymentAmount);

                        error = DataBase.PrintReachPayInvoicePaid(paymentSavedCard.requestDetails.invoiceNumber, payAmount, paymentSavedCard.transactionID.ToString(),paymentSavedCard.requestDetails.customerId ,paymentSavedCard.surchargeDetails.surchargeAmount);
                    }
                    else
                    {
                        string payAmount;
                        decimal paymentAmount = 0;
                        decimal surCharge = 0;

                        decimal.TryParse(payment.surchargeDetails.surchargeAmount, out surCharge);

                        paymentAmount = payment.gatewayResponse.amountDetails.approvedTotalAmount - surCharge;
                        decimal.Round(paymentAmount, 2);

                        payAmount = String.Format("{0:0.00}", paymentAmount);

                        error = DataBase.PrintReachPayInvoicePaid(payment.requestDetails.invoiceNumber, payAmount, payment.gatewayResponse.transactionID.ToString(), payment.requestDetails.customerId, payment.surchargeDetails.surchargeAmount);
                    }
                }

                if (error == "") //Log a success if a no error
                {

                    if (paymentType == "savecard")
                    {
                        Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt ") + paymentSavedCard.requestDetails.invoiceNumber + " invoice paid - Amount: " + paymentSavedCard.amountDetails.approvedTotalAmount, "_PrintReachPayWebhookLog");
                    }
                    else
                    {
                        Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt ") + payment.requestDetails.invoiceNumber + " invoice paid - Amount: " + payment.gatewayResponse.amountDetails.approvedTotalAmount, "_PrintReachPayWebhookLog");

                    }

                    response.isSuccessful = true;
                    response.data = "Successful";
                    context.Response.StatusCode = (int)System.Net.HttpStatusCode.OK;
                    context.Response.Write(JsonConvert.SerializeObject(response));
                }
                else
                {
                    response.error = error;
                    context.Response.StatusCode = (int)System.Net.HttpStatusCode.InternalServerError;
                    context.Response.Write(JsonConvert.SerializeObject(response));
                    Files.WriteErrorLog(DateTime.Now.ToString("MM/dd/yyyy h:mm tt") + " - PrintReach Pay Payment Failure: Internal Server error/n Json: " + decodedbody, "_PrintReachPayWebhookLog");
                }

            }
            else
            {
                response.error = "This listener does not support this request type";
                context.Response.StatusCode = (int)System.Net.HttpStatusCode.MethodNotAllowed;
                context.Response.Write(JsonConvert.SerializeObject(response));
            }
        }
        catch (Exception e)
        {

            context.Response.StatusCode = (int)System.Net.HttpStatusCode.BadRequest;
            response.error = e.Message;
            context.Response.Write(JsonConvert.SerializeObject(response));
        }
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }

}