﻿
function WindowOpenFile(URL) {
    WindowOpen(URL, "_blank", 0, 0); // URL is loaded into a new window. This is default
}

    //  name is optional. It specifies the target attribute or the name of the window. The following values are supported:
    //  •_blank - URL is loaded into a new window. This is default
    //  •_parent - URL is loaded into the parent frame
    //  •_self - URL replaces the current page
    //  •_top - URL replaces any framesets that may be loaded

function WindowOpen(url, name, DocW, DocH) {

    var PdfDPI = screen.deviceXDPI || 96;
    //var PdfDPI = 110;

    if (DocW == undefined || DocW == 0) DocW = Math.ceil(8.5 * PdfDPI);
    if (DocH == undefined || DocH == 0) DocH = Math.ceil(11.0 * PdfDPI);

    DocW += 30;
    DocH += 30;

    // Method A: Calculate the new window size based on PlanWeb window and center it within PlanWeb window
    var availW  = window.innerWidth  || document.documentElement.clientWidth  || document.body.clientWidth;
    var availH  = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    var winY    = window.screenY || window.screenTop  || 0;
    var winX    = window.screenX || window.screenLeft || 0;

    var NewWinW = Math.max(100, Math.min(DocW, availW)); // min 100
    var NewWinH = Math.max(100, Math.min(DocH, availH))  // ;

    var NewWinX = winX  + Math.ceil(Math.max(0, (availW - NewWinW) / 2)); // center relative to parent
    var NewWinY = winY  + Math.ceil(Math.max(0, (availH - NewWinH) / 2)); // = top of the browser's main window (below heading, toolbar)

    /*
    // Method B: Calculate the new window size based on full screen and center it on full screen
    NewWinW = Math.max(100, Math.min(DocW, screen.availWidth));
    NewWinH = Math.max(100, Math.min(DocH, screen.availHeight));
    NewWinY = Math.max(0, Math.round((screen.availHeight - NewWinH) / 2)); // center horz. on screen
    NewWinX = Math.max(0, Math.round((screen.availWidth - NewWinW) / 2)); // center vert. on screen
    */

    var params
        = "width=" + NewWinW
        + ",height=" + NewWinH
        + ",top=" + NewWinY
        + ",left=" + NewWinX
        + ",menubar=0"
        + ",resizable=1"
        + ",status=0"
        + ",scrollbars=1"
        + ",toolbar=0";

    var newwin = window.open(url, name, params);

    if (window.focus) {
        newwin.focus();
    }

    return false;
}


//////////////////////////// GOOGLE //////////////////////////////////////////////
/*
var geocoder;
var map;
var marker;

function initialize() {
    geocoder = new google.maps.Geocoder();
    var latlng = new google.maps.LatLng(40.730885, -73.997383);
    var mapOptions = { zoom: 8, center: latlng, mapTypeId: google.maps.MapTypeId.ROADMAP }
    map = new google.maps.Map(document.getElementById("map_canvas"), mapOptions);
}

function codeAddress()
{
    var address = document.getElementById("address").value;
    geocoder.geocode(
		{ 'address': address },
		function (results, status) {
		    if (status == google.maps.GeocoderStatus.OK) {
		        map.setCenter(results[0].geometry.location);
		        var marker = new google.maps.Marker({ map: map, position: results[0].geometry.location });
		    }
		    else {
		        alert("Geocoder failed due to: " + status);
		    }
		}
	)
}
*/
